## Imports ##
import urllib,urllib2, json, re, unicodedata
from nltk.tokenize import WhitespaceTokenizer 
from cPickle import load
import nltk #NEEDS OPTIMISING


## Containers ##
class Container(object):
	def __init__(self):
		pass
	def setattr(self,k,v):
		try:
			setattr(self,k,v)
			return self.k
		except:
			return False
	def getattr(self,k):
		try:
			if hasattr(self, k):
				return getattr(self,k)
			else:	
				raise Exception()
		except:
				return False

class TastyPieContainer(Container):
	def __init__(self, data=None):
		if data is not None:
			if isinstance(data, dict):
				for k, v in data.iteritems():
					setattr(self, k, v)
					
## Collections ##
class TastyPieCollection(object):
	def __init__(self, data=None):
		self.data = {}
		if isinstance(data, (list, tuple)):
			i=0
			for item in data:
				self.data[i] = item

## Services ##
class ExternalService(Container):
	serviceList = ['twitter'] #OPTIMISE TO FACTORY
	library=None
	presetList={}
	
	def __init__(self):
		pass
		
	def _presetConversion(self, key):
		if key not in self.getattr('_presetList'):
			return False
		else:
			base = self.getattr('_presetList')[key]
			return base
		
class ServerService(ExternalService):
	def __init__(self):
		pass
		
class UserService(ExternalService):
	def __init__(self):
		pass
		
## Methods ##
class URLFetch(Container):
	base = method = None
	def __init__(self, base=None, method=None):
		if(isinstance(base,basestring) and len(base) > 0):
			self.setattr('base',base)
		if(isinstance(method,basestring) and len(method) > 0):
			self.setattr('method',method)
			
	def _build(self, params):
		url = self.getattr('base')+self.getattr('method')
		if(isinstance(params, dict) and len(params) > 0):
			url+='?'
			for k,v in params.iteritems():
				url += '&'+k+'='+v
		return url	
			
	def fetch(self, params):
		url = self._build(params)
		print url
		try:
			response = urllib2.urlopen(url)
			connection= response.read()
			return connection
		except:
			return False
			
class BasicFileImporter:	
	def __init__ (self):
		pass
		
	def loadFile(self, path=None):
		try:
			importedFile = open(path,'rb')
		except:
			print 'Import Error: File does not exist.'
			return False
		else:
			try:
				loadedFile = load(importedFile)
			except:
				print 'Load Error: File could not be loaded.'
				return False
			else:
				importedFile.close()
				return loadedFile
			
class StringCleaner: #NEEDS OPTIMISATION
	
	blacklist = dict()
	segmenters = dict()
		
	def __init__(self, bl=u'{[(\\/\'"#', wl=u',.:;?!}])@'):
		self.blacklist = dict((ord(char), None) for char in bl)
		self.segmenters = dict((ord(char), None) for char in wl)
		
	def clean(self,tokenizedText):		
		tokenizer = WhitespaceTokenizer()
		tokenizedText = tokenizer.tokenize(tokenizedText)	
		
		textSegmentations = [[]]
		token_size = len(tokenizedText)	
		for key, token in enumerate(tokenizedText):
			
			if(token.startswith('RT')):continue
			token = unicode(token)
			token = unicode(unicodedata.normalize('NFKD', token).encode('ascii', 'ignore'))
			if(len(token) == 0): continue
			if(re.findall('((?:http[s]?://|www.|pic.)[^"\' ]+)', token)):
				continue
		
		
			beforeBreakPoint=i=0
			if(len(token[0].translate(self.segmenters)) == 0):#if character ending punctuation

				token=token[1:]#remove character
				beforeBreakPoint=1
		
			for i in range(i,len(token)): #Cycle through characters
				if(len(token[i].translate(self.blacklist)) == 0) or (len(token[i].translate(self.segmenters)) == 0):#if character starting or ending punctuation				
					continue
				else: 
	
					break #Until valid character is found
			
			token=token[i:] #Remove excess punctuation from start		
			afterBreakPoint=j=cutOff=0
			if len(token) > 0: #If any characters remain
				for j in range(j,len(token)): #Cycle through characters
					i=len(token)-1-j                    
					if(len(token[i].translate(self.blacklist)) == 0) or (len(token[i].translate(self.segmenters)) == 0):#if character starting or ending punctuation
						cutOff=i;
						if(len(token[i].translate(self.segmenters)) == 0):
							afterBreakPoint=1			
						if(len(token) == 1):token = ''
						continue
					else: break #Until valid character is found		

				if(cutOff>0): token=token[:-(len(token)-cutOff)]


				if(beforeBreakPoint==1) and (len(textSegmentations[-1]) != 0):
					textSegmentations.append([])
				
				if(len(token)>0):	
					textSegmentations[-1].append(token)
				
				if(afterBreakPoint==1) and (key+1 != token_size) and (len(textSegmentations[-1]) != 0):
					textSegmentations.append([])
		
		response = TastyPieCollection()
		
		textSegmentations = [" ".join(i) for i in textSegmentations]

		for k, segment in enumerate(textSegmentations):
			response.data[k] = TastyPieContainer({
				'segment' : segment
			})

		return response
		
class LanguageProcessor: # NEEDS OPTIMISATION
	taggerLoc = '/home/lt99399/chimaera/api/library/t3.pkl'
	tagger = None
	defaultGrammar = ["{<.*TL>*<NN.*>?}",'{<KW.*|CD><CD|KW.*>}','{<DT|JJ.*>*<NNS.*>+}','{<NN.*|VB.*|KW>?<IN><NN.*|KW>}','{<VB.*>}','{<NP.*>}','{<JJ.*>}']

	

	
	def __init__ (self, taggerOverride=None):
		if taggerOverride == None:
			fi = BasicFileImporter()
			self.tagger = fi.loadFile(self.taggerLoc)
		else:
			self.tagger = taggerOverride
	
	def posTagger(self, segment):
		#tags = TastyPieCollection();
		segment = self.tagger.tag(segment)
		return segment
		"""for key, word in enumerate(segment):
			tags.data[key] = {
				'keyword' : word[0],
				'pos' : word[1]
			}
		return tags"""
		
	def posChunker(self, segmentList, chunkOnly=False, grammar=defaultGrammar):
		gr = """{vars}"""
		joinr = {"vars":"KW: "+("\nKW: ".join(grammar))}	
		grammar = gr.format(**joinr)

		parser = nltk.RegexpParser(grammar, loop=2)
		keywords = TastyPieCollection()
		def keyword_extract(branch):
			if isinstance(branch, nltk.tree.Tree):
				subBranches=branch.leaves()
				if len(subBranches) > 1:
					flattened = branch.flatten()
					flattened = (' '.join(elem[0] for elem in flattened))
					keywords.data[len(keywords.data)] = TastyPieContainer({
						'keyword' : flattened.encode('utf-8')
					})
					for sub in branch:
						keyword_extract(sub)
				elif chunkOnly is False:
					for currentKeyword in keywords.data.itervalues():
						if(nltk.metrics.edit_distance(branch[0][0].encode('utf-8'), currentKeyword.keyword) < 3):
							return
					keywords.data[len(keywords.data)] = TastyPieContainer({
						'keyword' : branch[0][0].encode('utf-8')
					})
					
		for key, segment in enumerate(segmentList):
			segment = parser.parse(segment)
			for cluster in segment:	
				if not isinstance(cluster, tuple):
					keyword_extract(cluster)
					
		return keywords
		

		
	
