from lib_common import ServerService, URLFetch, TastyPieCollection, TastyPieContainer
import urllib, json

class Freebase(ServerService):
	def __init__(self):
		pass
		
	
		
	def getEntity(self,params,getFull=True):
		defaultParams = {
			'key' : 'AIzaSyDXr3LvurRjpDxeN3XqzitjwrtNEBmW0aE',
			#'exact' : 'true',
			'limit' : '1',
		}
		defaultParams.update(params)
		connection = URLFetch(
			'https://www.googleapis.com/',
			'freebase/v1/search'
		)
		
		response = connection.fetch(defaultParams) #Get entity id1
		response = json.loads(response)
		entities = TastyPieCollection()	
		
		for rr, result in enumerate(response['result']):
			output = ''
			if 'output' in result:
				output = result['output']

			entities.data[rr] = TastyPieContainer({
				"mid" : result["mid"],
				"name" : result["name"],
				"notable_type" :  (result["notable"]["name"] if 'notable' in result else 'Unknown'),
				"score" : (result["score"] if 'score' in result else 0),
				"output" : output
			})
			if getFull == True:
				connection.method='freebase/v1/topic'+result["mid"]
				info = connection.fetch({'key' : 'AIzaSyDXr3LvurRjpDxeN3XqzitjwrtNEBmW0aE'}) #Get entity id
				info = json.loads(info)
				
				if '/common/topic/alias' in info['property']:
					temp = []
					for k,v in enumerate(info['property']['/common/topic/alias']['values']):
						temp.append(v['value'])
					entities.data[rr].setattr('alias',temp)
					
				if '/common/topic/description' in info['property']:
					entities.data[rr].setattr('description',info['property']['/common/topic/description']['values'][0]['value'])
				else:
					entities.data[rr].setattr('description','No description available.')
				
				if '/common/topic/image' in info['property']:
					imglist = int(info['property']['/common/topic/image']['count'])
					if(imglist) != 0:
						entities.data[rr].setattr('image','https://usercontent.googleapis.com/freebase/v1/image'+info['property']['/common/topic/image']['values'][imglist-1]['id'])

				if '/common/topic/notable_types' in info['property']:
					temp = []
					for k,v in enumerate(info['property']['/common/topic/notable_types']['values']):
						split = v['id'].split('/')
						split.pop(0)
						blacklist = ['base','user','media_common','symbols']
						if split[0] in blacklist:
							continue
						if k != 0: 
							temp.append(v['text'].lower())	
						temp += [(x.replace ("_", " ")).lower() for x in split]
					temp = list(set(temp))
					entities.data[rr].setattr('affiliated',temp)
	
		return entities
	
"""params = {'query':urllib.quote('skywalker'.strip()),'limit':'5'}
a = Freebase()
b = a.getEntity(params)

for x in b.data.itervalues():
	for k, v in x.__dict__.iteritems():
		print str(k)+': '+unicode(v)"""
		
