from cPickle import load
from nltk.tokenize import WhitespaceTokenizer
import re
import unicodedata
import nltk # fix
import json

class Container(object):
	pass

class TastyPieContainer(Container):
	def __init__(self, data=None):
		if data is not None:
			if isinstance(data, dict):
				for k, v in data.items():
					setattr(self, k, v)

class TastyPieCollection(object):
	def __init__(self, data=None):
		self.data = {}
		if isinstance(data, (list, tuple)):
			i=0
			for item in data:
				self.data[i] = item


class TextContainer(Container):
	def __init__(self, dataDict):
		for a, b in dataDict.items():
			if isinstance(b, (list, tuple)):
				setattr(self, a, [TextContainer(x) if isinstance(x, dict) else x for x in b])
			else:
				setattr(self, a, TextContainer(b) if isinstance(b, dict) else b)
				
	def getStaticAttribute(self,attrName):
		if hasattr(self, attrName):
			return getattr(self,attrName)
		else:	
			return False
			
	def getPrecision(self, setA, setB):	
		try:
			setA = set(setA)
			setB = set(setB)
			return len(setB.intersection(setA))/float(len(setA))
		except:
			return False

class BasicFileImporter:	
	def __init__ (self):
		pass
		
	def loadFile(self, path=None):
		try:
			importedFile = open(path,'rb')
		except:
			print 'Import Error: File does not exist.'
			return False
		else:
			try:
				loadedFile = load(importedFile)
			except:
				print 'Load Error: File could not be loaded.'
				return False
			else:
				importedFile.close()
				return loadedFile



				
class JsonDecoder:
	def __init__(self):
		pass
		
	def decode(self,inputJSON):
			try:
				return json.loads(inputJSON)
			except:
				return False
				
				
class StringCleaner:
	
	blacklist = dict()
	segmenters = dict()
		
	def __init__(self, bl, wl):
		self.blacklist = dict((ord(char), None) for char in bl)
		self.segmenters = dict((ord(char), None) for char in wl)
		
	def tokenizeString(self,aString):
		tokenizer = WhitespaceTokenizer()
		return tokenizer.tokenize(aString)
		
	def cleanTokens(self,tokenizedText):
		textSegmentations = [[]]
		token_size = len(tokenizedText)	
		for key, token in enumerate(tokenizedText):
			
			if(token.startswith('RT')):continue
			token = unicode(token)
			token = unicode(unicodedata.normalize('NFKD', token).encode('ascii', 'ignore'))
			if(len(token) == 0): continue
			if(re.findall('((?:http[s]?://|www.|pic.)[^"\' ]+)', token)):
				continue
		
		
			beforeBreakPoint=i=0
			if(len(token[0].translate(self.segmenters)) == 0):#if character ending punctuation

				token=token[1:]#remove character
				beforeBreakPoint=1
		
			for i in range(i,len(token)): #Cycle through characters
				if(len(token[i].translate(self.blacklist)) == 0) or (len(token[i].translate(self.segmenters)) == 0):#if character starting or ending punctuation				
					continue
				else: 
	
					break #Until valid character is found
			
			token=token[i:] #Remove excess punctuation from start		
			afterBreakPoint=j=cutOff=0
			if len(token) > 0: #If any characters remain
				for j in range(j,len(token)): #Cycle through characters
					i=len(token)-1-j                    
					if(len(token[i].translate(self.blacklist)) == 0) or (len(token[i].translate(self.segmenters)) == 0):#if character starting or ending punctuation
						cutOff=i;
						if(len(token[i].translate(self.segmenters)) == 0):
							afterBreakPoint=1			
						if(len(token) == 1):token = ''
						continue
					else: break #Until valid character is found		

				if(cutOff>0): token=token[:-(len(token)-cutOff)]


				if(beforeBreakPoint==1) and (len(textSegmentations[-1]) != 0):
					textSegmentations.append([])
				
				if(len(token)>0):	
					textSegmentations[-1].append(token)
				
				if(afterBreakPoint==1) and (key+1 != token_size) and (len(textSegmentations[-1]) != 0):
					textSegmentations.append([])
		return textSegmentations
		
		
class LanguageProcessor:
	taggerLoc = '/home/lt99399/chimaera/api/library/t3.pkl'
	tagger = None
	defaultGrammar =  "KW: {<.*TL>*<NN.*>?}KW: {<KW.*|CD><CD|KW.*>}KW: {<DT|JJ.*>*<NNS.*>+}KW: {<NN.*|VB|KW>?<IN><NN.*|KW>}KW: {<VB>}"			#KW: {<NP>}
	
	def __init__ (self, taggerOverride=None):
		if taggerOverride == None:
			fi = BasicFileImporter()
			self.tagger = fi.loadFile(self.taggerLoc)
		else:
			self.tagger = taggerOverride
	
	def posTagger(self, segmentList):
		for key, segment in enumerate(segmentList):
			segmentList[key] = self.tagger.tag(segment)
		return segmentList
		
	def posChunker(self, segmentList, grammar=defaultGrammar):
		parser = nltk.RegexpParser(grammar, loop=2)
		keywords = []
		def keyword_extract(branch):
			if isinstance(branch, nltk.tree.Tree):
				subBranches=branch.leaves()
				if len(subBranches) > 1:
					flattened = branch.flatten()
					flattened = (' '.join(elem[0] for elem in flattened))
					keywords.append(flattened.encode('utf-8'))
					for sub in branch:
						keyword_extract(sub)
				else:
					for currentKeyword in keywords:
						if(nltk.metrics.edit_distance(branch[0][0].encode('utf-8'), currentKeyword) < 3):
							return
					keywords.append(branch[0][0].encode('utf-8'))
					
		for key, segment in enumerate(segmentList):
			segment = parser.parse(segment)
			for cluster in segment:		
				if not isinstance(cluster, tuple):
					keyword_extract(cluster)

		return keywords
