# -*- coding: utf-8 -*-
import nltk
from nltk.tokenize import *
import nltk.data
import string
import re
import unicodedata
import lib_generic
import urllib

from lib_common import LanguageProcessor, StringCleaner, TastyPieCollection, TastyPieContainer
from lib_freebase import Freebase



class KeywordExtraction():
	def __init__ (self, taggerOverride=None):
		pass
		
	

		
	def extractLiteral(self,aString,grammar=False):
		sc = StringCleaner()
		cleanedTokens = sc.clean(aString)
		segmentedTokens = []
		for k,v in cleanedTokens.data.iteritems():
			if len(v.segment) == 0: continue #quirk
			segmentedTokens.append(v.segment.split())
					
		lp = LanguageProcessor()
		if grammar == False:
			response = lp.posChunker([lp.posTagger(x) for x in segmentedTokens])
		else:
			response = lp.posChunker([lp.posTagger(x) for x in segmentedTokens],False,grammar)
		return response
	
	
	
	def extractContext(self,keywords,treeStop=False,output='description'):
		if treeStop == True: 
			for k,x in enumerate(keywords):
				if (isinstance(x,basestring)):
					keywords[k] = str(x.strip()) #Doesn't allow for XML output
				else:
					keywords[k] = unicodedata.normalize('NFKD', x.strip()).encode('ascii','ignore')
		elif treeStop == False: keywords = [x.strip() for x in keywords]
		

		keywords.sort(key = len)
		keywords = keywords[::-1]
		tree = TastyPieContainer()
		
		def getNodes(branch):
			return [key for key, value in branch.iteritems()]
		
		def branchMatch(branch,term):
			nodes = getNodes(branch)
			for n in nodes:
				if term in n: return branchMatch(branch[n],term)
			branch[term] = dict()
			return branch
		
		#Build Tree
		for v in keywords:
			treeRootCount = len(tree.__dict__)
			if treeRootCount == 0:
				tree.setattr(v,dict())
			else:			
				branchMatch(tree.__dict__,v)

		if treeStop == True:
			treer = TastyPieCollection()
			#trees = getNodes(tree.__dict__)
			print type(tree.__dict__)
			treer.data[0] = TastyPieContainer({
				"trees"  : tree.__dict__
			})
			return treer
			
		#Query Freebase for the highest valid nodes
		f = Freebase()
		contextKeywords = TastyPieCollection()
		
		def traverseTree(branch):
			nodes = getNodes(branch)
			goDeeper = []
			found=False
			for n in nodes:
				b = checkIfEntity(n)
				if b == False:
					goDeeper.append(n)
			for n in goDeeper:
				traverseTree(branch[n])
			return contextKeywords
			
		def parseTypes(listOfDicts):
			temp = []
			typeCounter = 0
			for k,v in enumerate(listOfDicts):
				split = v['id'].split('/')
				if len(split) == 1: continue #quirk
				split.pop(0)
				blacklist = ['base','user','media_common','symbols','common','freebase']
				if split[0] in blacklist:
					continue
				if k != 0: 
					temp.append(v['name'].lower())	
				temp += [(x.replace ("_", " ")).lower() for x in split]
				if typeCounter == 4: break
				typeCounter+=1
			temp = list(set(temp))
			return temp		
			
			
	
		def checkIfEntity(x):
			x.replace("_"," ")
			print output
			#try:
			info = f.getEntity({'query':urllib.quote(x),'output':'('+output+')'},False)
			#print output
			if (len(info.data) == 1):
				if (info.data[0].score > 2):# and x in info.data[0].name):		
					try:
						b = contextKeywords.data[info.data[0].mid]
						return True
					except:
						if info.data[0].name == '' or info.data[0].score < 10: return False
						
						outputContent = None
						if output == 'type':
							outputContent= {'affiliated':parseTypes(info.data[0].output['type']['/type/object/type'])}
						else:
							#print info.data[0].output
							if len(info.data[0].output[output]) > 0:
								outputContent = info.data[0].output[output]
							else:
								outputContent = {output:'none'}
						
						
						contextKeywords.data[info.data[0].mid] = TastyPieContainer({
							"keyword" : x,		
							"freebase" : {
								"generalised_to" : info.data[0].name,
								"type" : info.data[0].notable_type,
								"relevancy_score" : info.data[0].score,
								output : outputContent
							}
						})
						#print 'aaaaaa'
						#print x
						#print info.data[0].description
						return True
						
				else:
					return False
			else:
				return False
			#except:
				#return False
				
				
		print tree.__dict__
		b2 = traverseTree(tree.__dict__)

		return contextKeywords
	

#a = KeywordExtraction()
#b = a.extractContext(["real breakthrough of google glass", "real", "breakthrough of google glass", "breakthrough", "google glass", "google", "glass", "controlling", "internet of things", "internet", "things"])
#print '------------'


#b = a.extractContext(['Indian fishermen','marines','Friday','Italy'])


"""sb = a.extractLiteral('Thrones! This is the swimmining Game of Thrones and, the Queen of Jacks')"

for k,v in b.data.iteritems():
	print v.__dict__
"""	
