
class Chromosome:
	tweetStats = None
	objectives = []
	domSet = set()
	domCount = 0
	front = None
	
	def __init__(self,dataItem,metrics): ##Initialise and set objectives (data items (x,y values) )
		self.tweetStats = dataItem
		try:
			self.objectives = [self.tweetStats.getattr('extended')[metric] for metric in metrics]			
			#print self.objectives
			#print
		except:
			#print 'failed'
			pass	
			

		#except:
		#		return False

		
		#if metric == 'tweet':
		#	self.objectives = [dataItem['tweetIGScore'],dataItem['tweetIRScore']]
		#else:
		#	self.objectives = [dataItem['authorIGScore'],dataItem['authorIRScore']]

	def setDomCount(self,value): ##Increment and Decrementing 'Dominated by' Value
		self.domCount += (value)
		return
				
	def setFront(self,front): ##Assign Front or 'Wave' for a set of Objectives (Data Item)
		self.front = front
		return
		
	def appendDomSet(self,chromosome): ##Add a chromosome that this Chromosome dominates to this Chromosome's 'Dominated by' list
		if (chromosome.__class__.__name__ == 'Chromosome'):
			temp = set([chromosome])
			self.domSet = self.domSet.union(temp)
			return True
		else: return False


#(a[1] < b[1] AND a[2] <= b[2]) OR (a[1] <= b[1] AND a[2] < b[2])		
	def dominates(self,chromosomeB):
		#domFlag = False
		
		a = self.objectives
		b = chromosomeB.objectives
		
		
		if ( (a[0] < b[0]) and (a[1] <= b[1]) ) or ( (a[0] <= b[0]) and (a[1] < b[1]) ):
			return False
		else:
			return True
		
		
		
		"""
		i=0
		for i in range(i,len(self.objectives)):
			if self.objectives[i] < chromosomeB.objectives[i]:
				return False
			elif self.objectives[i] >= chromosomeB.objectives[i]:
				domFlag = True
		"""
		return domFlag
		

"""
dataSet = [
	[6.0,4.2],
	[0,2.1],
	[1.0,1.5],
	[1.0,1.0],
	[2.4,1.8],
	[1.1,2.7],
	[7.7,1.2],
	[1.5,7.7],
	[2.8,3.2],
]
"""

#### Algorithm ####

def nsgaSort(dataSet,metrics):
	if len(metrics) % 2 != 0 or len(metrics) == 0:
		return False

	
	##Initialise Population
	population=[]
	frontedPopulation=[]
	for dataItem in dataSet:
		#print dataItem
		population.append(Chromosome(dataItem,metrics))
		#print population[-1].tweetStats.text
		#print population[-1].objectives
		#print
		
	##Phase 1
	for kc,c in enumerate(population): ##For each member of the population
		for kq, q in enumerate(population):
			if(kc == kq): continue
			if c.dominates(q):
				c.appendDomSet(q)
			else:
				c.setDomCount(1)
		if c.domCount == 0:
			c.setFront(1)
			#print str(c.objectives)+' belongs in Front: '+str(c.front)
			#print str(c.objectives)+' dominates: '+str([x.objectives for x in c.domSet])
			if len(frontedPopulation) == 0: frontedPopulation.append([])
			frontedPopulation[-1].append(c)
			

	#print
	#print ' [][][] Phase 2 [][][] '
	#print
	##Phase 2
	frontCounter=len(frontedPopulation)-1
	while (len(frontedPopulation[frontCounter]) != 0):
		#
		#print 'Processing through Layer: '+str(frontCounter+1)
		Q=[]
		for p in frontedPopulation[frontCounter]:
			#print 'Chromosome: '+str(p.objectives)+' dominates '+str(len(p.domSet))+' Chromosomes'
			for q in p.domSet:
				#print ' - Sub-Chromosome:'+str(q.objectives)
				q.setDomCount(-1)
				if (q.domCount == 0):
					q.setFront(frontCounter+1)
					Q.append(q)
		#print
		if len(Q) > 0:
			frontCounter += 1
			frontedPopulation.append([])
			#clearprint q.__dict__
			frontedPopulation[frontCounter] = Q
		else: break

	#print
	#print
	dictDataSet = {}
	for lk,layer in enumerate(frontedPopulation):
		
		 

		
		#print 'Layer: '+str(lk+1)
		for item in layer:
			item.tweetStats.getattr('extended')[('_and_'.join(metrics)+'_rank')] = lk+1
			dictDataSet[len(dictDataSet)] = item.tweetStats
			#print item.tweetStats.getattr('_and_'.join(metrics)+'_rank')
			#print str(item.objectives)+' - '+item.tweetStats.text+ ' - '+str(item.tweetStats.getLifetime())
		#print
		
	
	
	

	return dictDataSet


	


