from tastypie.resources import ModelResource
from tastypie import fields
from tastypie.authentication import Authentication
from tastypie.authorization import Authorization
from tastypie.bundle import Bundle
from tastypie.exceptions import NotFound
from tastypie.resources import Resource
from tastypie.cache import SimpleCache
from api.models import Entry
import knownIssuesImport as known_issues
from library.lib_twitter import TweetCollection, Tweet
from library.lib_keyword import KeywordExtraction
from library.lib_generic import  Container, JsonDecoder, TextContainer
from datetime import datetime
import json
import nltk
import unicodedata
import json
import numpy
import twitter
import re
import hashlib, uuid
import urllib, urllib2
from twitter.oauth_dance import parse_oauth_tokens as oauth_dance

from tastypie.models import create_api_key
from models import User, TwitterCredential

from library.lib_youtube import YouTube
from library.lib_news_pipe import NewsYahooPipe
from library.lib_flickr import Flickr
from library.lib_freebase import Freebase
from library.lib_twitter2 import TwitterConnection
from library.lib_common import StringCleaner, LanguageProcessor, TastyPieCollection, TastyPieContainer 
from library.lib_factories import ServiceFactory

class issuesResource(Resource):
	subject = fields.CharField(attribute = 'subject')
	detail = fields.CharField(attribute = 'detail')
	priority = fields.IntegerField(attribute = 'priority')
    
	class Meta:
		resource_name = 'issues'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		
	#def dehydrate_text(self, bundle):
	#	return bundle.data['text'].upper()
		
	def alter_list_data_to_serialize(self, request, data):
			data['meta'] = {
				'http': 200, #TODO
				'timestamp': datetime.strftime(datetime.now(), '%a %b %d %H:%M:%S +0000 %Y'),
				'results_count': data['meta']['total_count'],
			}
			
			data['content'] = data.pop('objects')
			for anObj in data['content']:
				for field_name in self._meta.field_list_to_remove:
					del anObj.data[field_name]
			return data
			
	def get_object_list(self, request):
		ds = known_issues.knownIssues()
		return ds.issueSet.values()
 
	def obj_get_list(self, request = None, **kwargs):
		return self.get_object_list(request)
 
	def obj_get(self, request = None, **kwargs):
		return



		
		
"""
class extendedTweetsResource(ReadOnlyResource):
	lifetime = fields.IntegerField(attribute = 'lifetime')
	keywords = fields.ListField(attribute = 'keywords')
	precision = fields.DictField(attribute = 'precision')
	user = fields.DictField(attribute = 'user')	
	
	class Meta:
		resource_name = 'extendedTweets'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
			
	def get_object_list(self, request):
		
		
		connection = Twitter (
			api_version='1.1',
			auth=OAuth(
				'587307932-aYEfHGvWmg3O7VMmUOz0zAg1ki4RP6mLVAkJ6PfQ',
				'IMFBoQ0huqWWqdYTDSjoYpxZ5dzHoWVlFbh9SWvHFnI',
				'TwBgKt5194KFgwrbskRpA',
				'ECtwrTl1gWaLC9Ja0gAhyyPtpd1dXOVDJgbMz6U'
			)
		)

		searchTerms = ['Tomatoes']
		a = connection.search.tweets(q=(','.join(searchTerms)),lang='en',count=10)
		jsonDecoder = JsonDecoder()
		TC = TweetCollection(a['statuses'])	
		NJ = TC.getPrecisionAgainst(jsonDecoder.decode(json.dumps({"search": ["a","b","c","Tomatoes"],"new": ["1","2","3","4","tomatoes"]})))
		TC = TC.getRankingScores()
		#print TC[0].precision
		def todict(obj, classkey=None):
			print '------'
			if isinstance(obj, Tweet) or isinstance(obj, TextContainer):
				
				temp = {}
				#print 'yes' + str(obj.__dict__)
				for k,v in obj.__dict__.iteritems():
					temp[k] = todict(v)
					#print temp[k]
					
				obj = temp
					#obj.__dict__[k] = todict(v)
			#	for k,v in obj.__dict__.iteritems():
			#		obj[k] = todict(obj[k], classkey)
			#	return obj
			#elif hasattr(obj, "__iter__"):
			#	return [todict(v, classkey) for v in obj]
			#elif hasattr(obj, "__dict__"):
			#	data = dict([(key, todict(value, classkey)) 
			#		for key, value in obj.__dict__.iteritems() 
			#		if not callable(value) and not key.startswith('_')])
			#	if classkey is not None and hasattr(obj, "__class__"):
			#		data[classkey] = obj.__class__.__name__
			#	return data\d
				#print 'no - '+str(obj)
				#print  type(obj)
			return obj
				
		response = dict()
		for k,v in enumerate(TC):
			#print k
			#print v
			#print type(v)
			#print (todict(v).__dict__)
			v = todict(v)
			
			y = Container()
			for p,q in v.iteritems():			
				setattr(y, p, q)
			#r = dict(response=y)
			
			response[k] = y#TextContainer(v)
			#print response[k].__dict__
			#print response[k]
			#break
		#k:todict(v) }
		#print response
		
		#print type(TC)
		return response.values()
		#return dict().values()		
"""


############################################################################
# Template #

class ReadOnlyResource(Resource):
	class Meta:
		pass
		
	def alter_list_data_to_serialize(self, request, data):
			data['meta'] = {
				'status': self.Meta.status,
				'timestamp': datetime.strftime(datetime.now(), '%a %b %d %H:%M:%S +0000 %Y'),
				'results_count': data['meta']['total_count'],
			}
			
			data['content'] = data.pop('objects')
			for anObj in data['content']:
				for field_name in self._meta.field_list_to_remove:
					del anObj.data[field_name]
			return data

	def get_object_list(self, request):
		return {}.values()

	def obj_get_list(self, request = None, **kwargs):
		return self.get_object_list(request)
 
	def obj_get(self, request = None, **kwargs):
		return



############################################################################
# Semantics #

class relatedYouTubeResource(ReadOnlyResource):
	title = fields.CharField(attribute = 'title')
	thumbnail = fields.CharField(attribute = 'thumbnail')
	url = fields.CharField(attribute = 'url')
	description = fields.CharField(attribute = 'description')
	publishedAt = fields.CharField(attribute = 'publishedAt')
	
	class Meta:
		resource_name = 'youtube'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'

	def get_object_list(self, request):
		if not 'q' in request.GET or len(request.GET['q']) == 0: 
			self.Meta.status = 'error'
			return {}.values()		
		exclusionList = ['format','compareAgainst']
		
		params = {}
		for k,v in request.GET.iteritems():
			if k not in exclusionList:
				if k == 'q':
					try:
						v = json.loads(v) # e.g. q={"keywords":%20["A"generate,"B"]}
						v = ['"'+urllib.quote(x.strip())+'"' for x in next(v.itervalues())]
					except: # e.g. q=a,b
						v = ['"'+urllib.quote(x.strip())+'"' for x in v.split(',') if len(v) != 0]
					v = '%20OR%20'.join(v)
				params[k] = v	

		y = YouTube()
		vids = y.getVideos(params)
		return vids.data.values()


class relatedNewsYahooPipeResource(ReadOnlyResource):
	title = fields.CharField(attribute = 'title')
	url = fields.CharField(attribute = 'url')
	description = fields.CharField(attribute = 'description')
	publishedAt = fields.CharField(attribute = 'publishedAt')
	
	class Meta:
		resource_name = 'news'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'

	def get_object_list(self, request):
		if not 'q' in request.GET or len(request.GET['q']) == 0: 
			self.Meta.status = 'error'
			return {}.values()
		
		exclusionList = ['format','compareAgainst']
		
		params = {}
		for k,v in request.GET.iteritems():
			if k not in exclusionList:
				if k == 'q':
					try:
						v = json.loads(v) # e.g. q={"keywords":%20["A","B"]}
						v = [urllib.quote(x.strip()) for x in next(v.itervalues())]
					except: # e.g. q=a,b
						v = [urllib.quote(x.strip()) for x in v.split(',') if len(v) != 0]
					v = '%20OR%20'.join(v)
					print
					print v
					print
					k = 'searchInput'
				params[k] = v	



		n = NewsYahooPipe()
		news = n.getNews(params)
		return news.data.values()
		
class relatedFlickrResource(ReadOnlyResource):
	title = fields.CharField(attribute = 'title')
	thumbnail = fields.CharField(attribute = 'thumbnail')
	url = fields.CharField(attribute = 'url')
	description = fields.CharField(attribute = 'description')
	tags = fields.ListField(attribute = 'tags')
	author = fields.CharField(attribute = 'author')
	publishedAt = fields.CharField(attribute = 'publishedAt')
	
	class Meta:
		resource_name = 'flickr'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'

	def get_object_list(self, request):
		if not 'q' in request.GET or len(request.GET['q']) == 0: 
			self.Meta.status = 'error'
			return {}.values()
		
		exclusionList = ['format','compareAgainst']
		
		params = {}
		for k,v in request.GET.iteritems():
			if k not in exclusionList:
				if k == 'q':
					try:
						v = json.loads(v) # e.g. q={"keywords":%20["A","B"]}
						v = ['"'+urllib.quote(x.strip())+'"' for x in next(v.itervalues())]
					except: # e.g. q=a,b
						v = ['"'+urllib.quote(x.strip())+'"' for x in v.split(',') if len(v) != 0]
					v = ',%20'.join(v)
					k = 'tags'
				params[k] = v	

		f = Flickr()
		photos = f.getPhotos(params)
		return photos.data.values()
		
class entityInformationResource(ReadOnlyResource):
	mid = fields.CharField(attribute = 'mid')
	name = fields.CharField(attribute = 'name')
	notable_type = fields.CharField(attribute = 'notable_type')
	alias = fields.ListField(attribute = 'alias', null=True)
	description = fields.CharField(attribute = 'description')
	image = fields.CharField(attribute = 'image', null=True)
	affiliated = fields.ListField(attribute = 'affiliated', null=True)
	
	class Meta:
		resource_name = 'entity_information'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'

	def get_object_list(self, request):
		if not 'q' in request.GET or len(request.GET['q']) == 0: 
			self.Meta.status = 'error'
			return {}.values()		
		exclusionList = ['format','compareAgainst']
		
		params = {}
		for k,v in request.GET.iteritems():
			if k not in exclusionList:
				if k == 'q':
					try:
						v = json.loads(v) # e.g. q={"keywords":%20["A","B"]}
						v = ['"'+urllib.quote(x.strip())+'"' for x in next(v.itervalues())]
					except: # e.g. q=a,b
						v = ['"'+urllib.quote(x.strip())+'"' for x in v.split(',') if len(v) != 0]
					v = '%20OR%20'.join(v)
					k = 'query'
				params[k] = v	

		f = Freebase()
		info = f.getEntity(params)
		return info.data.values()


############################################################################

class sourceParser(object):
    def __init__(self):pass
 
    def decode(self,q,apikey):
		split = q.split(':')
		if len(split) < 2:
			return q
		else:
			sf = ServiceFactory()
			dr = sf.generate(split[0].strip(), apikey)
			if (dr==False): return q
			variables={}
			if len(split) > 2:
				for v in split[2].split(','):
					v = v.split('=')
					if len(v) > 1: variables[v[0].strip()] = v[1].strip()
			uio = dr.parseKeywords(split[1],variables)
			return uio

############################################################################
# Keyword #
class keywordResource(ReadOnlyResource):
	keyword = fields.CharField(attribute = 'keyword')
	
	class Meta:
		#object_class = dict_to_obj
		resource_name = 'keywordExtraction'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
		
	def get_object_list(self, request):
		k = KeywordExtraction()
		
		if 'q' in request.GET and len(request.GET['q']) > 0:
			if 'apikey' in request.GET and len(request.GET['apikey']) > 0:
				dS = sourceParser()
				r = dS.decode(request.GET['q'],request.GET['apikey'])
				if (isinstance(r, basestring)):
					r = k.extractLiteral(request.GET['q'])
				#r = k.extractLiteral(request.GET['q'],request.GET['apikey'])
				return r.data.values()				
			else:
				r = k.extractLiteral(request.GET['q'])
				return r.data.values()
		else: 
			self.Meta.status = 'error'
			return {}.values()
			
class entityResource(ReadOnlyResource): #Example Tweets - Italy says marines accused of killing Indian fishermen will return to India on Friday
	keyword = fields.CharField(attribute = 'keyword')
	freebase = fields.DictField(attribute = 'freebase')
	class Meta:
		resource_name = 'entityExtraction'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
		
	def get_object_list(self, request):
		k = KeywordExtraction()
		if 'q' in request.GET and len(request.GET['q']) > 0:		
			if 'apikey' in request.GET and len(request.GET['apikey']) > 0:
				dS = sourceParser()
				r = dS.decode(request.GET['q'],request.GET['apikey'])
				if (isinstance(r, basestring)):
					r = k.extractLiteral(re.sub('<[^<]+?>', '',request.GET['q']),["{<.*TL>*<NN.*>?}",'{<KW.*|CD><CD|KW.*>}','{<DT|JJ.*>*<NNS.*>+}','{<NN.*|KW>?<IN><NN.*|KW>}','{<NP.*>}'])
				
				if 'output' in request.GET and len(request.GET['output']) > 0:
					r = k.extractContext([x.keyword for x in r.data.values()],False,request.GET['output'])
				else:
					r = k.extractContext([x.keyword for x in r.data.values()])
				return r.data.values()				
			else:
				r = k.extractLiteral(re.sub('<[^<]+?>', '',request.GET['q']),["{<.*TL>*<NN.*>?}",'{<KW.*|CD><CD|KW.*>}','{<DT|JJ.*>*<NNS.*>+}','{<NN.*|KW>?<IN><NN.*|KW>}','{<NP.*>}'])
				
				#print request.GET['output']
				if 'output' in request.GET and len(request.GET['output']) > 0:
					r = k.extractContext([x.keyword for x in r.data.values()],False,request.GET['output'])
				else:
					r = k.extractContext([x.keyword for x in r.data.values()])
				return r.data.values()
		else: 
			self.Meta.status = 'error'
			return {}.values()

class substringTreeResource(ReadOnlyResource): #Example Tweets - Italy says marines accused of killing Indian fishermen will return to India on Friday
	trees = fields.DictField(attribute = 'trees')
	class Meta:
		resource_name = 'substringTree'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
		
	def get_object_list(self, request):
		k = KeywordExtraction()
		if 'q' in request.GET and len(request.GET['q']) > 0:
			if 'apikey' in request.GET and len(request.GET['apikey']) > 0:
				dS = sourceParser()
				r = dS.decode(request.GET['q'],request.GET['apikey'])
				print '*************'
				print r.data.values()
				print '*************'
				if ((isinstance(r, basestring)) or (not(hasattr(r,'data')))):
					self.Meta.status = 'error'
					return {}.values()
				else:
					r = k.extractContext([x.keyword for x in r.data.values()],True)
				return r.data.values()				
			else:
				r = k.extractContext(request.GET['q'].split(','),True)
				return r.data.values()
		else: 
			self.Meta.status = 'error'
			return {}.values()

class stringCleanResource(ReadOnlyResource):
	segment = fields.CharField(attribute = 'segment')
	
	class Meta:
		resource_name = 'stringClean'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
			
	def get_object_list(self, request):
		defaultBlacklist = u'{[(\\/\'"#'
		defaultSegmenters = u',.:;?!}])@'
		
		if 'q' in request.GET and len(request.GET['q']) > 0:
			sc = StringCleaner((request.GET['blacklist'] if 'blacklist' in request.GET else defaultBlacklist),(request.GET['segmenters'] if 'segmenters' in request.GET else defaultSegmenters))
			cleanedTokens = sc.clean(request.GET['q'])
			return cleanedTokens.data.values()
		else:
			self.Meta.status = 'error'
			return {}.values()

class posTagResource(keywordResource):
	pos = fields.CharField(attribute = 'pos')
	class Meta:
		resource_name = 'posTag'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
			
	def get_object_list(self, request):
		if 'q' in request.GET and len(request.GET['q']) > 0:
			try:
				q = json.loads(request.GET['q']) # e.g. q={"keywords":%20["a","b","c"]}
				q = next(q.itervalues())
			except: # e.g. q=a,b
				q = [x.strip() for x in request.GET['q'].split(',') if len(x) != 0]

			lp = LanguageProcessor()
			segmentedTokens = lp.posTagger(q)
			
			response = TastyPieCollection()
			for key, word in enumerate(segmentedTokens):
				response.data[key] = TastyPieContainer({
					'keyword' : word[0],
					'pos' : word[1]
				})
			return response.data.values()
		else:
			self.Meta.status = 'error'
			return {}.values()

class posChunkResource(keywordResource): # Returns all 'keywords' it finds not just chunks
	class Meta:
		resource_name = 'posChunk'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
			
	def get_object_list(self, request):
		if 'q' in request.GET and len(request.GET['q']) > 0:
			try:
				q = json.loads(request.GET['q']) # e.g. q={"keywords":%20["A","B"]}
				q = next(q.itervalues())
				
				lp = LanguageProcessor()
				treeString = [[]]
				for ty in q:
					tup = ty['keyword'],ty['pos']
					treeString[0].append(tup)
							
				b = lp.posChunker(treeString, (True if 'type' in request.GET and request.GET['type'] == 'chunks' else False))
				return b.data.values()
			except:
				self.Meta.status = 'error'
				return {}.values()
		else:
			self.Meta.status = 'error'
			return {}.values()


############################################################################
# Twitter #

class twitterToolsResource(ReadOnlyResource):
	response = fields.DictField(attribute = 'response')
	
	class Meta:
		resource_name = 'twittertools'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
		

	def alter_list_data_to_serialize(self, request, data):
			data['meta'] = {
				'status': self.Meta.status,
				'timestamp': datetime.strftime(datetime.now(), '%a %b %d %H:%M:%S +0000 %Y'),
				'results_count': data['meta']['total_count'],
			}
			
			data['content'] = data.pop('objects')
			for anObj in data['content']:
				for field_name in self._meta.field_list_to_remove:
					del anObj.data[field_name]
					
			data['content'] = data['content'][0].data['response']['abc'] #quirk
			return data
					
	def get_object_list(self, request):
		if 'function' in request.GET and len(request.GET['function']) > 0:
			exclusionList = ['format','function','apikey']
			variables = {}
			for x in request.GET:
				if x not in exclusionList:
					variables[x] = request.GET[x]
					
			sf = ServiceFactory()	
			tc = sf.generate('twitter',request.GET['apikey'])
			
			#tc = TwitterConnection(request.GET['apikey'])
			a = tc.library_function(request.GET['function'],variables)
			response = TastyPieCollection()
			response.data[0] = TastyPieContainer({
				'response' : {'abc':a}
			})		
			return response.data.values()
		else:
			self.Meta.status = 'error'
			return {}.values()
			
			
			

class extendedTweetsResource(ReadOnlyResource):
	extended = fields.DictField(attribute = 'extended')
	original = fields.DictField(attribute = 'original')	
	
	class Meta:
		resource_name = 'extendedTweets'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
		#cache = SimpleCache() Cache not available
					
	def get_object_list(self, request):
		if 'source' in request.GET and len(request.GET['source']) > 0: source = request.GET['source']
		"""try:"""
		sf = ServiceFactory()
		try:
			source = json.loads(source)
			source = next(source.itervalues())				
		except:
			split = source.split(':')
			print split
			if len(split) < 2 : raise Exception()
			service = sf.generate(split[0],request.GET['apikey']) #call factory, generate instance of a service e.g. TwitterConnection
			variables = {}
			if len(split) > 2:
				for v in split[2].split(','):
					v = v.split('=')
					if len(v) > 1: variables[v[0].strip()] = v[1].strip()
			try:
				source = service.parseSource(split[1].strip(),variables)
			except:
				return {}.values() #BAD SOLUTION

		#print 'b'


		##Now for keyword precision sets
		if 'precisionSets' in request.GET and len(request.GET['precisionSets']) > 0:
			#print 'test'
			precisionSets = request.GET['precisionSets']
			precisionSets2 = {}

			try:
				json3 = json.loads(precisionSets)
				precisionSets = next(json3.itervalues())
			except:
				precisionSets = [precisionSets]
				
			for aSet in precisionSets:
				split = aSet.split(':')
				if len(split) < 2:
					precisionSets2['unnamed'] = [x.strip() for x in split.split(',')]
				else:
					if split[0].startswith('_'):
						precisionSets2[split[0][1:]] = [x.strip() for x in split[1].split(',')]
					else:
						dr = sf.generate(split[0].strip(), request.GET['apikey'])
						variables={}
						if len(split) > 2:
							for v in split[2].split(','):
								v = v.split('=')
								if len(v) > 1: variables[v[0].strip()] = v[1].strip()

						uio = dr.parseKeywords(split[1],variables)
						if hasattr(uio,'data'):
							precisionSets2[split[0]+'_'+split[1]] = [x.keyword for k,x in uio.data.iteritems()]
		else: precisionSets2 = {}
		#print 'a'
		#print precisionSets2
		#print
			
		if 'rank' in request.GET: 
			if request.GET['rank'].lower() == 'false':
				a = service.extendedSourceInfo(source,precisionSets2,False)
				return a.data.values()				
		a = service.extendedSourceInfo(source,precisionSets2)
		return a.data.values()

































"""
class templateResource(Resource):
	text = fields.CharField(attribute = 'text')
    
	class Meta:
		resource_name = 'template'
		object_class = template.Entry
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		
	#def dehydrate_text(self, bundle):
	#	return bundle.data['text'].upper()
		
	def alter_list_data_to_serialize(self, request, data):
			data['meta'] = {
				'http': 200, #TODO
				'timestamp': datetime.strftime(datetime.now(), '%a %b %d %H:%M:%S +0000 %Y'),
				'results_count': data['meta']['total_count'],
			}
			
			data['content'] = data.pop('objects')
			for anObj in data['content']:
				for field_name in self._meta.field_list_to_remove:
					del anObj.data[field_name]
			return data
			
	def get_object_list(self, request):
		ds = template.DataSet()
		return ds.data.values()
 
	def obj_get_list(self, request = None, **kwargs):
		return self.get_object_list(request)
 
	def obj_get(self, request = None, **kwargs):
		return
"""	
"""

class RowResource(Resource):
    # fields must map to the attributes in the Row class
    id = fields.IntegerField(attribute = 'id')
    name = fields.CharField(attribute = 'name')
    
    class Meta:
        resource_name = 'row'
        object_class = row.Row
        authentication = Authentication()
        authorization = Authorization()
		
    # adapted this from ModelResource
    def get_resource_uri(self, bundle_or_obj):
        kwargs = {
            'resource_name': self._meta.resource_name,
        }
 
        if isinstance(bundle_or_obj, Bundle):
            kwargs['pk'] = bundle_or_obj.obj.id # pk is referenced in ModelResource
        else:
            kwargs['pk'] = bundle_or_obj.id
        
        if self._meta.api_name is not None:
            kwargs['api_name'] = self._meta.api_name
        
        return self._build_reverse_url('api_dispatch_detail', kwargs = kwargs)
 
    def get_object_list(self, request):
        # inner get of object list... this is where you'll need to
        # fetch the data from what ever data source
        
        ds = row.DataSet(request.GET.getlist('b'))
        return ds.data.values()
 
    def obj_get_list(self, request = None, **kwargs):
        # outer get of object list... this calls get_object_list and
        # could be a point at which additional filtering may be applied
        return self.get_object_list(request)
 
    def obj_get(self, request = None, **kwargs):
        # get one object from data source
        pk = int(kwargs['pk'])
        try:
            return data[pk]
        except KeyError:
            raise NotFound("Object not found") 
    
    def obj_create(self, bundle, request = None, **kwargs):
        # create a new row
        bundle.obj = Row()
        
        # full_hydrate does the heavy lifting mapping the
        # POST-ed payload key/values to object attribute/values
        bundle = self.full_hydrate(bundle)
        
        # we add it to our in-memory data dict for fun
        data[bundle.obj.id] = bundle.obj
        return bundle
    
    def obj_update(self, bundle, request = None, **kwargs):
        # update an existing row
        pk = int(kwargs['pk'])
        try:
            bundle.obj = data[pk]
        except KeyError:
            raise NotFound("Object not found")
        
        # let full_hydrate do its work
        bundle = self.full_hydrate(bundle)
        
        # update existing row in data dict
        data[pk] = bundle.obj
        return bundle

"""

"""

class validateResource(Resource):
	text = fields.CharField(attribute = 'response')
	class Meta:
		resource_name = 'validate'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get','post']
		authorization= Authorization()

	def deserialize(self, request, data, format='application/json'):
		print request.POST
		try:
			return super(validateResource, self).deserialize(request, data, format=format)
		except Exception as e:
			print e
			# if an exception occurred here it must be due to deserialization
			raise ImmediateHttpResponse(response=http.HttpBadRequest(e.message))

	def alter_list_data_to_serialize(self, request, data):
			data['meta'] = {
				'http': 200, #TODO
				'timestamp': datetime.strftime(datetime.now(), '%a %b %d %H:%M:%S +0000 %Y'),
				'results_count': data['meta']['total_count'],
			}
			
			temp = data.pop('objects')
			for anObj in temp:
				for field_name in self._meta.field_list_to_remove:
					del anObj.data[field_name]
				for k,v in anObj.data.items():
					data[k] = v
			return data
			
	def get_object_list(self, request):
		r=dict()
		print request.POST
		try:
			
			return r.values()
		except:
			y = Container()
			setattr(y, 'response', 'An Error Occured')
			r[0] = y			
			return r.values()

	def obj_get_list(self, request = None, **kwargs):
		return self.get_object_list(request)
 
	def obj_get(self, request = None, **kwargs):
		return

	def obj_create(self, bundle, request=None, **kwargs):
		print request
	 	return bundle



"""



class loginResource(Resource):
	credentials = fields.DictField(attribute = 'credentials', null=True)
	
	class Meta:
		resource_name = 'login'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
		
	def alter_list_data_to_serialize(self, request, data):
			data['meta'] = {
				'timestamp': datetime.strftime(datetime.now(), '%a %b %d %H:%M:%S +0000 %Y'),
				'results_count': data['meta']['total_count'],
				'status' : self.Meta.status
			}
			
			temp = data.pop('objects')
			for anObj in temp:
				for field_name in self._meta.field_list_to_remove:
					del anObj.data[field_name]
				for k,v in anObj.data.items():
					data[k] = v
			return data
			
	def get_object_list(self, request):
		response = dict()
		genkey = uuid.uuid4().hex
		
		if 'via' in request.GET and request.GET['via'].strip().lower() == 'twitter':			
			app_name = "Chimaera Project"
			consumer_key = "TwBgKt5194KFgwrbskRpA"
			consumer_secret = "ECtwrTl1gWaLC9Ja0gAhyyPtpd1dXOVDJgbMz6U"
			twitterConnect = twitter.Twitter(
				api_version=None,auth=twitter.oauth.OAuth('','',consumer_key, consumer_secret),format=''
			)
			try:
				
				oauth_token, oauth_token_secret = oauth_dance(twitterConnect.oauth.request_token())

				response[0] = TastyPieContainer({
					'credentials':{
						'url':'http://api.twitter.com/oauth/authenticate?oauth_token=' + oauth_token
					}
				})
				return response.values()
			except:
				self.Meta.status = 'error'
				return dict().values()

		self.Meta.status = 'error'
		return dict().values()

	def obj_get_list(self, request = None, **kwargs):
		return self.get_object_list(request)
 
	def obj_get(self, request = None, **kwargs):
		return




class authoriseResource(Resource):
	apikey = fields.CharField(attribute = 'apikey')
	credentials = fields.DictField(attribute = 'credentials', null=True)
	
	class Meta:
		resource_name = 'authorise'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
		
	def alter_list_data_to_serialize(self, request, data):
			data['meta'] = {
				'timestamp': datetime.strftime(datetime.now(), '%a %b %d %H:%M:%S +0000 %Y'),
				'results_count': data['meta']['total_count'],
				'status' : self.Meta.status
			}
			
			temp = data.pop('objects')
			for anObj in temp:
				for field_name in self._meta.field_list_to_remove:
					del anObj.data[field_name]
				for k,v in anObj.data.items():
					data[k] = v
			return data
			
	def get_object_list(self, request):
		response = dict()
		genkey = uuid.uuid4().hex
		
		if 'type' not in request.GET:
			try:
				b = User.objects.get(apikey=request.GET['apikey'])
			except:
				print 'no user for that key'
				b = User(apikey=genkey)
				b.save()
			response[0] = TastyPieContainer({'apikey':b.apikey})
			return response.values()
		else:
			if request.GET['type'].strip().lower() == 'twitter':			
				app_name = "Chimaera Project"
				consumer_key = "TwBgKt5194KFgwrbskRpA"
				consumer_secret = "ECtwrTl1gWaLC9Ja0gAhyyPtpd1dXOVDJgbMz6U"
				twitterConnect = twitter.Twitter(
					api_version=None,auth=twitter.oauth.OAuth('','',consumer_key, consumer_secret),format=''
				)
				try:
					oauth_token, oauth_token_secret = oauth_dance(twitterConnect.oauth.request_token())
					
					c = TwitterCredential.objects.filter(apikey=request.GET['apikey'])
					if len(c) > 0:
						print 'updating a twitter users request tokens'
						b = TwitterCredential.objects.get(apikey=request.GET['apikey'])
						print
						print b.status
						b.oauthtoken = oauth_token
						b.oauthsecret = oauth_token_secret
						b.save()
						
					else:
						c = User.objects.filter(apikey=request.GET['apikey'])
						if len(c) > 0:
							print 'adding twitter for a user'
							b = TwitterCredential(user_ptr_id=c[0].pk, status='r', oauthtoken=oauth_token, oauthsecret=oauth_token_secret)
							b.__dict__.update(c[0].__dict__)
							b.save()				
						else:
							print 'new user being created'
							b = TwitterCredential(apikey=genkey, status='r', oauthtoken=oauth_token, oauthsecret=oauth_token_secret)
							b.save()
					
					response[0] = TastyPieContainer({
						'apikey':b.apikey,
						'credentials':{'url':'http://api.twitter.com/oauth/authenticate?oauth_token=' + oauth_token}
					})
					return response.values()
				except:
					self.Meta.status = 'error'
					return dict().values()				
		self.Meta.status = 'error'
		return dict().values()

	def obj_get_list(self, request = None, **kwargs):
		return self.get_object_list(request)
 
	def obj_get(self, request = None, **kwargs):
		return


class validateResource(Resource):
	apikey = fields.CharField(attribute = 'apikey')
	validated = fields.BooleanField(attribute = 'validated')
	
	class Meta:
		resource_name = 'validate'
		field_list_to_remove = ['resource_uri']
		detail_allowed_methods = []
		list_allowed_methods = ['get']
		status = 'ok'
		
	def alter_list_data_to_serialize(self, request, data):
			data['meta'] = {
				'timestamp': datetime.strftime(datetime.now(), '%a %b %d %H:%M:%S +0000 %Y'),
				'results_count': data['meta']['total_count'],
				'status' : self.Meta.status
			}
			
			temp = data.pop('objects')
			for anObj in temp:
				for field_name in self._meta.field_list_to_remove:
					del anObj.data[field_name]
				for k,v in anObj.data.items():
					data[k] = v
			return data
			
	def get_object_list(self, request):
		if 'type' in request.GET:
			if request.GET['type'].strip().lower() == 'twitter':	
				response = dict()

				app_name = "Chimaera Project"
				consumer_key = "TwBgKt5194KFgwrbskRpA"
				consumer_secret = "ECtwrTl1gWaLC9Ja0gAhyyPtpd1dXOVDJgbMz6U"

				twitterConnect = twitter.Twitter(
					api_version=None,
					auth=twitter.oauth.OAuth(
						request.GET['oauth_token'],
						'',
						consumer_key,
						consumer_secret
					),
					format=''
				)
				oauth_verifier = request.GET['oauth_verifier']
				oauth_token, oauth_token_secret = oauth_dance(twitterConnect.oauth.access_token(oauth_verifier=oauth_verifier))
				
				try:
					user = TwitterCredential.objects.get(oauthtoken=request.GET['oauth_token'])	
					print 'yes1'
					user.oauthtoken = oauth_token
					user.oauthsecret = oauth_token_secret
					user.save()
				except:
					try:
						print '---'
						print oauth_token
						print '---'
						user = TwitterCredential.objects.get(oauthtoken=oauth_token)	
						print user				
					except:
						print 'yes'
						user = TwitterCredential(apikey=uuid.uuid4().hex, status='a', oauthtoken=oauth_token, oauthsecret=oauth_token_secret)
						user.save()				
				
				print
				print oauth_token
				print oauth_token_secret
				print
				response[0] = TastyPieContainer({
					'apikey':user.apikey,
					'validated':True
				})	
				return response.values()
			return dict().values()
				
		self.Meta.status = 'error'
		return dict().values()
		"""
		if 'type' in request.GET:
			if request.GET['type'].strip().lower() == 'twitter':
				if 'oauth_token' in request.GET:
					user = TwitterCredential.objects.filter(oauthtoken=request.GET['oauth_token'])
					if len(user) > 0:
						user = TwitterCredential.objects.get(oauthtoken=request.GET['oauth_token'])		
						if 'oauth_verifier' in request.GET:
							oauth_verifier = request.GET['oauth_verifier']

							app_name = "Chimaera Project"
							consumer_key = "TwBgKt5194KFgwrbskRpA"
							consumer_secret = "ECtwrTl1gWaLC9Ja0gAhyyPtpd1dXOVDJgbMz6U"

							twitterConnect = twitter.Twitter(
								api_version=None,
								auth=twitter.oauth.OAuth(
									user.oauthtoken,
									'',
									consumer_key,
									consumer_secret
								),
								format=''
							)
							print 'tt'
							try:
								oauth_token, oauth_token_secret = oauth_dance(twitterConnect.oauth.access_token(oauth_verifier=oauth_verifier))

								print 'oldoauth '+user.oauthtoken+' ~~ secret: '+user.oauthsecret
								print 'newoauth '+oauth_token+' ~~ secret: '+oauth_token_secret
								#if oauth_token != user.oauthtoken and oauth_token_secret != user.oauthsecret:
								#	user.status = 'a'
								#	user.oauthtoken = oauth_token
								#	user.oauthsecret = oauth_token_secret
								#	user.save()
									#print 'updated oauth'
									
								response[0] = TastyPieContainer({
									'apikey':user.apikey,
									'validated':True
								})	
								return response.values()
									
							except:
								#response[0] = TastyPieContainer({
								#	'apikey':user.apikey,
								#	'validated':False
								#})	
								return response.values()	

		
		#Pin Based [Redundant]

		genkey = uuid.uuid4().hex
		
		if 'apikey' in request.GET:
			user = TwitterCredential.objects.filter(apikey=request.GET['apikey'].strip())
			if len(user) > 0:
				user = TwitterCredential.objects.get(apikey=request.GET['apikey'].strip())
				if 'type' in request.GET:
					if request.GET['type'].strip().lower() == 'twitter':		
						if 'verifier' in request.GET:
							oauth_verifier = request.GET['verifier']

							app_name = "Chimaera Project"
							consumer_key = "TwBgKt5194KFgwrbskRpA"
							consumer_secret = "ECtwrTl1gWaLC9Ja0gAhyyPtpd1dXOVDJgbMz6U"

							twitterConnect = twitter.Twitter(
								api_version=None,
								auth=twitter.oauth.OAuth(
									user.oauthtoken,
									user.oauthsecret,
									consumer_key,
									consumer_secret
								),
								format=''
							)

							try:
								oauth_token, oauth_token_secret = oauth_dance(twitterConnect.oauth.access_token(oauth_verifier=oauth_verifier))

								if len(oauth_token) != 0 and len(oauth_token_secret) !=0:
									#user.oauthtoken = oauth_token
									#user.oauthsecret = oauth_token_secret
									#user.save()
									
									response[0] = TastyPieContainer({
										'apikey':user.apikey,
										'validated':True
									})	
									return response.values()
								else:
									raise Exception()
									
							except:
								response[0] = TastyPieContainer({
									'apikey':user.apikey,
									'validated':False
								})	
								return response.values()
								
				
		"""	
	def obj_get_list(self, request = None, **kwargs):
		return self.get_object_list(request)
 
	def obj_get(self, request = None, **kwargs):
		return





"""
		if 'q' in request.GET:
			try:
				q = json.loads(request.GET['q']) # e.g. q={"keywords":%20["A","B"]}
				q = next(q.itervalues())
			except: # e.g. q=a,b
				q = [x.strip() for x in request.GET['q'].split(',') if len(x) != 0]

			lp = LanguageProcessor()
			segmentedTokens = lp.posTagger([q])
			
			r=dict()
			setattr(y, 'response', obj[0])
			r[0] = y
		return dict().values()
"""











