from django.conf.urls import patterns, include, url
from api.resources import substringTreeResource, entityResource,loginResource,validateResource,authoriseResource,twitterToolsResource,extendedTweetsResource,entityInformationResource,relatedFlickrResource,relatedYouTubeResource,relatedNewsYahooPipeResource,keywordResource,stringCleanResource,posTagResource,posChunkResource

#issuesResource

from chimaera_client.views import playground, client_index, timelines, newsfuse, tweetgraph

#issues_resource = issuesResource()
keyword_resource = keywordResource()
entity_resource = entityResource()
substringTree_resource = substringTreeResource()
stringClean_resource = stringCleanResource()
posTag_resource = posTagResource()
posChunk_resource = posChunkResource()

extendedTweets_resource = extendedTweetsResource()
twitterTools_resource = twitterToolsResource()

relatedYoutube_resource = relatedYouTubeResource()
relatedNewsYahooPipe_resource = relatedNewsYahooPipeResource()
relatedFlickr_resource = relatedFlickrResource()
entityInformation_resource = entityInformationResource()

auth_resource = authoriseResource()
val_resource = validateResource()
login_resource = loginResource()

base = 'api'
current_version = '1'

urlpatterns = patterns('',
	#(r'^'+base+'/', include(issues_resource.urls)),
	(r'^'+base+'/'+current_version+'/toolkit/', include(keyword_resource.urls)),
	(r'^'+base+'/'+current_version+'/toolkit/', include(entity_resource.urls)),
	
	(r'^'+base+'/'+current_version+'/toolkit/', include(substringTree_resource.urls)),	
	(r'^'+base+'/'+current_version+'/toolkit/', include(stringClean_resource.urls)),
	(r'^'+base+'/'+current_version+'/toolkit/', include(posTag_resource.urls)),
	(r'^'+base+'/'+current_version+'/toolkit/', include(posChunk_resource.urls)),
	
	(r'^'+base+'/'+current_version+'/semantics/', include(relatedYoutube_resource.urls)),
	(r'^'+base+'/'+current_version+'/semantics/', include(relatedNewsYahooPipe_resource.urls)),	
	(r'^'+base+'/'+current_version+'/semantics/', include(relatedFlickr_resource.urls)),	
	(r'^'+base+'/'+current_version+'/semantics/', include(entityInformation_resource.urls)),	
	
	(r'^'+base+'/'+current_version+'/experimental/', include(extendedTweets_resource.urls)),
	(r'^'+base+'/'+current_version+'/experimental/', include(twitterTools_resource.urls)),
	(r'^'+base+'/'+current_version+'/experimental/auth/', include(auth_resource.urls)),	
	(r'^'+base+'/'+current_version+'/experimental/auth/', include(val_resource.urls)),	
	(r'^'+base+'/'+current_version+'/experimental/auth/', include(login_resource.urls)),
	
	(r'^client/$', client_index),
	(r'^client/apps/timelines$', timelines),
	(r'^client/apps/newsfuse$', newsfuse),
	(r'^client/apps/tweetgraph$', tweetgraph),
	(r'^client/apps/playground$', playground),



#from chimaera.views import *

# Uncomment the next two lines to enable the admin:
# from django.contrib import admin
# admin.autodiscover()



	#('^hello/$', hello), #reg expression hello url pattern ^$ from parent and child directories in url
	#('^time/$', current_datetime),
	#(r'^time/plus/(\d{1,2})/$', hours_ahead),

	
	
    # Examples:
    # url(r'^$', 'chimaera.views.home', name='home'),
    # url(r'^chimaera/', include('chimaera.foo.urls')),

    # Uncomment the admin/doc line below to enable admin documentation:
    # url(r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    # url(r'^admin/', include(admin.site.urls)),
)
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
urlpatterns += staticfiles_urlpatterns()
