$(document).ready(function()    {

	$("#search_submit").click(function(){
		if ($("#search_field").val().trim() == ''){
			return false
		}

		var clicked = $(this)
		$.each(clicked.parent().parent().siblings(),function (index,item) {
			$(item).hide("slow");
			$(item).remove()
	    }); 
	    clicked.parent().siblings().hide("fast")
	    $("#app_content").append("<br>");

	    $("#app_content").append("<section id=\"semantic-block\"></section>").show("fast");
	    	$("#semantic-block").spin();

	    $("#app_content").append("<section id=\"videos-block\"><h2>Videos </h2></section>").show("fast");
			$("#videos-block").spin();

	    $("#app_content").append("<section id=\"images-block\"><h2>Images </h2></section>").show("fast");
			$("#images-block").spin();

	    $("#app_content").append("<section id=\"news-block\"><h2>News </h2></section>").show("fast");
			$("#news-block").spin();

	    $.fetch(
	    	'semantics/entity_information',
	    	['q='+$("#search_field").val().trim()],
	    	'parseSemantics'
	    )

	    $.fetch(
	    	'semantics/youtube',
	    	['q='+$("#search_field").val().trim()],
	    	'parseYouTube'
	    )

	    $.fetch(
	    	'semantics/flickr',
	    	['q='+$("#search_field").val().trim()],
	    	'parseFlickr'
	    )

	    $.fetch(
	    	'semantics/news',
	    	['q='+$("#search_field").val().trim(),'limit=5'],
	    	'parseNews'
	    )


		return false;


    	
    	
	});

});


function parseYouTube(msg){
	var items = [];
	$("#videos-block .spinner").remove();

	if ($.map(msg.content, function(n, i) { return i; }).length == 0) {
		$('#videos-block').append('<p>No results found...</p>');
	}
	else{
		for (var key in msg.content) {
		   var obj = msg.content[key];
		   var entry = '<li title="'+obj['title']+'">'

		   entry += '<a href="'+(obj['url'])+'" target="_blank"><img src="'+obj['thumbnail']+'"> </img></a>';
		   items.push(entry+'</li>');
		}
		$('#videos-block').append('<ul class="grid-list-video">'+items.join('')+'</ul>');

	}
}

function parseFlickr(msg){
	var items = [];
	$("#images-block .spinner").remove();

	if ($.map(msg.content, function(n, i) { return i; }).length == 0) {
		$('#images-block').append('<p>No results found...</p>');
	}
	else{
		for (var key in msg.content) {
		   var obj = msg.content[key];
		   var entry = '<li title="'+obj['title']+' - '+obj['tags'].join()+'">'

		   entry += '<a href="'+(obj['url'])+'" target="_blank"><img src="'+obj['thumbnail']+'"> </img></a>';
		   items.push(entry+'</li>');
		}
		$('#images-block').append('<ul class="grid-list-images">'+items.join('')+'</ul>');

	}
}

function parseSemantics(msg){
	var items = [];
	$("#semantic-block .spinner").remove();

	if ($.map(msg.content, function(n, i) { return i; }).length == 0) {
		$('#semantic-block').append('<p>No results found...</p>');
	}
	else{
		for (var key in msg.content) {
		   var obj = msg.content[key];


		   if (obj["alias"] != null) {var alias = ' <span>(Also Known As: '+obj["alias"].join(', ')+')</span>'} 
		   	else {var alias = ''};

		   items.push("<h2>"+obj["name"]+alias+"</h2>")

		   items.push('<h3>'+obj["notable_type"]+'</h3>')

		   items.push('<p>'+obj["description"]+'</p>')

		   if (obj["affiliated"] != null) {
		   		var ul = '<ul class="tag-list">'
		   		ul += obj["affiliated"].map(function(item) {return '<li>'+item+'</li>';}).join('');
				ul += '</ul>'
		   		items.push(ul)
		   }
		}
		$('#semantic-block').append(items.join(''));
	}
}

function parseNews(msg){
	var items = [];
	$("#news-block .spinner").remove();

	if ($.map(msg.content, function(n, i) { return i; }).length == 0) {
		$('#news-block').append('<p>No results found...</p>');
	}
	else{
		for (var key in msg.content) {
		   var obj = msg.content[key];
		   var entry = '<li>'

		   entry += '<p><a href="'+obj["url"]+'" target="_blank">'+obj["title"]+' </a></p><span>'+obj["publishedAt"]+'</span>';
		   entry += '<p>'+obj["description"]+'</p>';
		   items.push(entry+'</li>');
		}
		$('#news-block').append('<ul class="news-list">'+items.join('')+'</ul>');
	}
}











